<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <h2 class="page-title">realtime discussion test4</h2>
    <span style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video muted controls width="100%" ref="myVideo"/>
      <span> 내 화면 </span>
    </span>

    <span v-for="user in userList" v-bind:key="user.socket_id" style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video muted controls width="100%" :ref="user.socket_id"/>
      <span> {{ user.from_name }} </span>
    </span>
    <el-button @click="changeRate"> changeRate </el-button>
  </div>
</template>

<script>
import lectureService from '../../services/lectureService';
import utils from '../../utils';

export default {
  name: 'RealtimeWebcamLecture',
  data() {
    return {
      // webRTC
      pc: [],
      offer: [],
      configuration: {
        iceServers: [
          {
            urls: 'stun:stun.l.google.com:19302',
          },
        ],
      },
      hasVideo: false, // 접속자 시스템에 비디오, 오디오 여부
      hasAudio: false,
      userList: [],
      localStream: undefined,
    };
  },
  async mounted() {
    const vm = this;   
    vm.localStream = await navigator.mediaDevices.getUserMedia({
      audio: true,
      video: { frameRate: { ideal: 3, max: 3 }, width: 1280, height: 720 },
    });
    vm.$refs.myVideo.srcObject = vm.localStream;

    console.log('from_name: utils.getNameFromJwt(), = ', utils.getNameFromJwt());

    // 입장 사실 서버에 알림
    vm.$socket.emit('DISCUSSION' , JSON.stringify({
      discussion_room_id: vm.discussionRoomId,
      from_email_id: utils.getEmailFromJwt(),
      from_name: utils.getNameFromJwt(),
    }));

    vm.sockets.subscribe('DISCUSSION', async (evt) => {
      const signal = JSON.parse(evt);

      // 이미 연결된적이 있는 유저인지 찾는다.
      let userIndex = -1;
      vm.userList.forEach((element, index) => {
        // if (element.email_id === signal.from_email_id) {
        if (element.socket_id === signal.from_socket_id) {
          userIndex = index;
        }
      })
      // 만약 저장되지 않았다면, 저장하고 인덱스를 리턴한다.
      if (userIndex === -1) {
        // vm.userList.push({ email_id: signal.from_email_id });
        vm.userList.push({ socket_id: signal.from_socket_id, from_name: signal.from_name, from_email_id: signal.from_email_id });
        userIndex = vm.userList.length - 1;
      }

      if (signal.call_me || signal.offer) {
        console.log(userIndex, ': on call_me or offer (pc created)');
        vm.pc[userIndex] = new RTCPeerConnection(vm.configuration);
        vm.localStream.getTracks().forEach(track => {
          vm.pc[userIndex].addTrack(track, vm.localStream);
        });

        const offer = await vm.pc[userIndex].createOffer();
        vm.offer[userIndex] = offer;

        if (signal.call_me) {
          console.log(userIndex, ': on call_me');
          vm.$socket.emit('DISCUSSION' , JSON.stringify({
            to_socket_id: signal.from_socket_id,
            from_email_id: utils.getEmailFromJwt(),
            from_name: utils.getNameFromJwt(),
            offer,
          }));
          console.log(userIndex, ': emit offer');
        }

        // Listen for local ICE candidates on the local RTCPeerConnection
        vm.pc[userIndex].addEventListener('icecandidate', event => {
          if (event.candidate) {
            vm.$socket.emit('DISCUSSION', JSON.stringify({
              candidate: event.candidate,
              to_socket_id: signal.from_socket_id,
              from_email_id: utils.getEmailFromJwt(),
              from_name: utils.getNameFromJwt(),
            }));
            console.log(userIndex, ': emit icecandidate');
          }
        });

        vm.pc[userIndex].addEventListener('connectionstatechange', event => {
          if (vm.pc[userIndex].connectionState === 'connected') {
            console.log(userIndex, ': peer connected!');
          }
          if (vm.pc[userIndex].connectionState === 'disconnected') {
            console.log(userIndex, ': peer disconnected!');
            vm.userList.splice(userIndex, 1);
          }
        });

        const remoteStream = new MediaStream();
        // vm.$refs[`userVideo${userIndex}`][0].srcObject = remoteStream;
        vm.$refs[signal.from_socket_id][0].srcObject = remoteStream;
        vm.pc[userIndex].addEventListener('track', async (event) => {
          console.log(userIndex, ': @track ☆★☆★');
          remoteStream.addTrack(event.track, remoteStream);
        });
      }
      if (signal.offer) {
        console.log(userIndex, ': on offer');
        vm.pc[userIndex].setRemoteDescription(new RTCSessionDescription(signal.offer));
        const answer = await vm.pc[userIndex].createAnswer();
        vm.$socket.emit('DISCUSSION', JSON.stringify({
          to_socket_id: signal.from_socket_id,
          from_email_id: utils.getEmailFromJwt(),
          from_name: utils.getNameFromJwt(),
          answer,
        }));
        console.log(userIndex, ': emit answer');
        await vm.pc[userIndex].setLocalDescription(answer);
      }
      if (signal.answer) {
        console.log(userIndex, ': on answer');
        const remoteDesc = new RTCSessionDescription(signal.answer);
        await vm.pc[userIndex].setLocalDescription(vm.offer[userIndex]);
        await vm.pc[userIndex].setRemoteDescription(remoteDesc);
      }
      if (signal.candidate) {
        try {
          await vm.pc[userIndex].addIceCandidate(signal.candidate);
          console.log(userIndex, ' : add icecandidate');
        } catch (e) {
          console.log(userIndex, ': Error adding received ice candidate');
          console.error(userIndex, ': Error adding received ice candidate', e);
        }
      }
    });
    
  },
  methods: {
    async changeRate() {
      console.log('changeRate');
      const vm = this;
      vm.localStream = await navigator.mediaDevices.getUserMedia({
      audio: true,
      video: false,
      });
      vm.$refs.myVideo.srcObject = vm.localStream;
      vm.$refs.myVideo.play();
    }
  },
  computed: {
    discussionRoomId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.discussionRoomId, 10);
    }
  },
};
</script>